/*
 * MudStorm OS
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <types.h>
#include <shell.h> 
#include <string.h>
#include <intr/gdt.h>
#include <intr/idt.h>
#include <intr/irq.h>
#include <intr/isrs.h>
#include <kbd/kb.h>
#include <timer.h>
#include <video.h>
#include <delay.h>
#include <stdio.h>
#include <io.h>

void _start(void *mbd, unsigned int magic)
{
	cls(); // Pulisco lo schermo
	
	printk("\t\t\t   VGA type: "); // Scrive a video
	if (!detect_videotype()) // Se la funzione ritorna false
	{
		set_color(GREEN + BLUE); // Le prossime scritte sarannò GREEN + BLUE
		printk("Colour\n"); // Scrive a video
		set_color(WHITE); // Le prossime scritte saranno WHITE
	}
	else // Altrimenti(se ritorna true)
	{
		printk("MonoChrome\n"); // Scrive a video
	}

	if (magic != 0x2BADB002) 
	{
		set_color(RED + BAK_WHITE);
		printk("\n\t\t\t\tErrore");
		set_color(WHITE);
		printk("\n\t\t\tSpegnere il Computer");
		asm ("cli");
		asm ("hlt");
	}

	gdt_install(); // Inizializzo le GDT
   	idt_install(); // Inizializzo gli IDT
   	isrs_install(); // Inizializzo le ISR
   	irq_install(); // Inizializzo gli IRQ
	timer_install(); // Inizializzo il timer
	keyboard_install(); // Inizializzo la tastiera
   	asm volatile ("sti"); // Abilito gli interrupt

	runShell(); // Esco da questa funzione ed entro in un'altra, contenuta nel file shell.h & shell.c
}
